// EthernetHostDlg.cpp : implementation file
//
//=============================================================================
// Ethernet Host Program Test
//
// [CEthernetHostDlg.cpp]
// by http://cafe.naver.com/elab 
//=============================================================================

/*
 - Ethernet Host Server Function 
 - String Send and Receive
*/
#include "stdafx.h"
#include "EthernetHost.h"
#include "EthernetHostDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MODE_CLIENT					FALSE
#define MODE_SERVER					TRUE
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
#include "ServerAsyncSocket.h"
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	CServerAsyncSocket m_ServerSocket;

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEthernetHostDlg dialog

CEthernetHostDlg::CEthernetHostDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEthernetHostDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEthernetHostDlg)
	m_strSend = _T("");
	m_strRecive = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_NetPort = 3000;
	m_FlagConnect = FALSE;
	m_IpAddress = "192.168.0.3";
	m_FlagMode = MODE_SERVER;
}

void CEthernetHostDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEthernetHostDlg)
	DDX_Text(pDX, IDC_EDIT1, m_strSend);
	DDX_Text(pDX, IDC_EDIT2, m_strRecive);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEthernetHostDlg, CDialog)
	//{{AFX_MSG_MAP(CEthernetHostDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEthernetHostDlg message handlers

BOOL CEthernetHostDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	SetDlgItemInt(IDC_EDIT3, m_NetPort);
	SetDlgItemText(IDC_IPADDRESS1, m_IpAddress);

	CButton *pCheck;
	pCheck=(CButton *)GetDlgItem(IDC_RADIO1);
	pCheck->SetCheck(TRUE);
	pCheck=(CButton *)GetDlgItem(IDC_RADIO2);
	pCheck->SetCheck(FALSE); 	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEthernetHostDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEthernetHostDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEthernetHostDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEthernetHostDlg::OnButton1() 
{
	UpdateData(TRUE);

	if(m_FlagMode == MODE_SERVER)
	{
		m_ServerSocket.m_Agent.Send(m_strSend, m_strSend.GetLength());
	}
	else
	{
		m_ClientSocket.Send(m_strSend, m_strSend.GetLength());
	}

	m_strSend.Empty();
	UpdateData(FALSE);
	GetDlgItem(IDC_EDIT1)->SetFocus();
}

void CEthernetHostDlg::OnClose() 
{
	m_ServerSocket.m_Agent.Close();

	CDialog::OnClose();
}

void CEthernetHostDlg::OnButton2() 
{

	if(m_FlagConnect == FALSE)
	{
		m_NetPort = GetDlgItemInt(IDC_EDIT3, NULL, TRUE);
		GetDlgItemText(IDC_IPADDRESS1, m_IpAddress);

		if(m_FlagMode == MODE_SERVER)
		{
			m_ServerSocket.Create(m_NetPort);
			m_ServerSocket.Listen();

			SetDlgItemText(IDC_STATIC_MSG, "Server Ready OK");
		}
		else
		{
			m_ClientSocket.Create();
			m_ClientSocket.Connect(m_IpAddress, m_NetPort);
			SetDlgItemText(IDC_STATIC_MSG, "Client  Ready OK");
		}

		m_FlagConnect = TRUE;
	}
	else
	{
		if(m_FlagMode == MODE_SERVER)
		{
			m_ServerSocket.m_Agent.Close();

			SetDlgItemText(IDC_STATIC_MSG, "Server Socket Close");
		}
		else
		{
			m_ClientSocket.Close();
			SetDlgItemText(IDC_STATIC_MSG, "Client Socket Close");
		}

		m_FlagConnect = FALSE;
	}

}

void CEthernetHostDlg::OnRadio1() 
{
	m_FlagMode = MODE_SERVER;
	
	SetDlgItemText(IDC_BUTTON2, "Listen");
	//	IDC_RADIO1
	
	CButton *pCheck;

	pCheck=(CButton *)GetDlgItem(IDC_RADIO2);
	pCheck->SetCheck(FALSE); 
}

void CEthernetHostDlg::OnRadio2() 
{
	m_FlagMode = MODE_CLIENT;
	
	SetDlgItemText(IDC_BUTTON2, "Connect");

	CButton *pCheck;

	pCheck=(CButton *)GetDlgItem(IDC_RADIO1);
	pCheck->SetCheck(FALSE); 
}
